#!/usr/bin/env/python 
# -*- coding: utf-8 -*-
##########
# Module:	yethan.py
# Auther:	Kim Song-yil
# E-mail:	masoris@gmail.com
# Date:		2008/01/05
##########
'''
한글 IME에 사용하기 위한 옛 한글 데이터베이스를 생성합니다.

옛한글 자료 데이터는 "옛한글첫가끝자모(탭)입력을위한첫가끝자모(탭)설명(탭)우선순위" 형태로 구성되어 있습니다.

우선순위를 나타내는 수치의 기준은 다음과 같습니다.
현대 초성: 3.3xx
옛 초성과 초성 채움: 1.3xx
현대 중성: 3.2xx
옛 중성과 중성 채움: 1.2xx
현대 종성과 無종성: 3.1xx
옛 종성: 1.1xx
방점: 0.0xx

다음은 예외입니다.
아래아와 아래야: 2.2xx (제주어)
'''

import unicodedata

chotext=u'''ᄀ	ᄀ	기역	3.399
ᄁ	ᄁ	쌍기역	3.398
ᄂ	ᄂ	니은	3.397
ᄃ	ᄃ	디귿	3.396
ᄄ	ᄄ	쌍디귿	3.395
ᄅ	ᄅ	리을	3.394
ᄆ	ᄆ	미음	3.393
ᄇ	ᄇ	비읍	3.392
ᄈ	ᄈ	쌍비읍	3.391
ᄉ	ᄉ	시옷	3.390
ᄊ	ᄊ	쌍시옷	3.389
ᄋ	ᄋ	이응	3.388
ᄌ	ᄌ	지읒	3.387
ᄍ	ᄍ	쌍지읒	3.386
ᄎ	ᄎ	치읓	3.385
ᄏ	ᄏ	키읔	3.384
ᄐ	ᄐ	티읕	3.383
ᄑ	ᄑ	피읖	3.382
ᄒ	ᄒ	히읗	3.381
ᄓ	ᄂ	니은기역	1.399
ᄔ	ᄂ	니은니은	1.398
ᄕ	ᄂ	니은디귿	1.397
ᄖ	ᄂ	니은비읍	1.396
ᄗ	ᄃ	디귿기역	1.395
ᄘ	ᄅ	리을니은	1.394
ᄙ	ᄅ	리을리을	1.393
ᄚ	ᄅ	리을히읗	1.392
ᄛ	ᄅ	여린리을	1.391
ᄜ	ᄆ	미음비읍	1.390
ᄝ	ᄆ	여린미음	1.389
ᄞ	ᄇ	비읍기역	1.388
ᄟ	ᄇ	비읍니은	1.387
ᄠ	ᄇ	비읍디귿	1.386
ᄡ	ᄇ	비읍시옷	1.385
ᄢ	ᄇ	비읍시옷기역	1.384
ᄣ	ᄇ	비읍시옷디귿	1.383
ᄤ	ᄇ	비읍시옷비읍	1.382
ᄥ	ᄇ	비읍쌍시옷	1.381
ᄦ	ᄇ	비읍시옷지읒	1.380
ᄧ	ᄇ	비읍지읒	1.379
ᄨ	ᄇ	비읍치읓	1.378
ᄩ	ᄇ	비읍티읕	1.377
ᄪ	ᄇ	비읍피읖	1.376
ᄫ	ᄇ	여린비읍	1.375
ᄬ	ᄇ	여린쌍비읍	1.374
ᄭ	ᄉ	시옷기역	1.373
ᄮ	ᄉ	시옷니은	1.372
ᄯ	ᄉ	시옷디귿	1.371
ᄰ	ᄉ	시옷리을	1.370
ᄱ	ᄉ	시옷미음	1.369
ᄲ	ᄉ	시옷비읍	1.368
ᄳ	ᄉ	시옷비읍기역	1.367
ᄴ	ᄉ	시옷쌍시옷	1.366
ᄵ	ᄉ	시옷이응	1.365
ᄶ	ᄉ	시옷지읒	1.364
ᄷ	ᄉ	시옷치읓	1.363
ᄸ	ᄉ	시옷키읔	1.362
ᄹ	ᄉ	시옷티읕	1.361
ᄺ	ᄉ	시옷피읖	1.360
ᄻ	ᄉ	시옷히읗	1.359
ᄼ	ᄉ	치두음시옷	1.358
ᄽ	ᄊ	치두음쌍시옷	1.357
ᄾ	ᄉ	정치음시옷	1.356
ᄿ	ᄊ	정치음쌍시옷	1.355
ᅀ	ᄉ	반시옷	1.354
ᅁ	ᄋ	이응기역	1.353
ᅂ	ᄋ	이응디귿	1.352
ᅃ	ᄋ	이응미음	1.351
ᅄ	ᄋ	이응비읍	1.350
ᅅ	ᄋ	이응시옷	1.349
ᅆ	ᄋ	이응반시옷	1.348
ᅇ	ᄋ	이응이응	1.347
ᅈ	ᄋ	이응지읒	1.346
ᅉ	ᄋ	이응치읓	1.345
ᅊ	ᄋ	이응티읕	1.344
ᅋ	ᄋ	이응피읖	1.343
ᅌ	ᄋ	옛이응	1.342
ᅍ	ᄌ	지읒이응	1.341
ᅎ	ᄌ	치두음지읒	1.340
ᅏ	ᄌ	치두음쌍지읒	1.339
ᅐ	ᄌ	정치음지읒	1.338
ᅑ	ᄌ	정치음쌍지읒	1.337
ᅒ	ᄎ	치읓키읔	1.336
ᅓ	ᄎ	치읓히읗	1.335
ᅔ	ᄎ	치두음치읓	1.334
ᅕ	ᄎ	정치음치읓	1.333
ᅖ	ᄑ	피읖비읍	1.332
ᅗ	ᄑ	여린피읖	1.331
ᅘ	ᄒ	쌍히읗	1.330
ᅙ	ᄒ	여린히읗	1.329
ᅟ	ᄋ	無초성	1.328'''
jungtext=u'''ᅡ	ᅡ	아	3.299
ᅢ	ᅢ	애	3.298
ᅣ	ᅣ	야	3.297
ᅤ	ᅤ	애	3.296
ᅥ	ᅥ	어	3.295
ᅦ	ᅦ	에	3.294
ᅧ	ᅧ	여	3.293
ᅨ	ᅨ	예	3.292
ᅩ	ᅩ	오	3.291
ᅪ	ᅪ	와	3.290
ᅫ	ᅫ	왜	3.289
ᅬ	ᅬ	외	3.288
ᅭ	ᅭ	요	3.287
ᅮ	ᅮ	우	3.286
ᅯ	ᅯ	워	3.285
ᅰ	ᅰ	웨	3.284
ᅱ	ᅱ	위	3.283
ᅲ	ᅲ	유	3.282
ᅳ	ᅳ	으	3.281
ᅴ	ᅴ	의	3.280
ᅵ	ᅵ	이	3.279
ᅶ	ᅡ	아오	1.299
ᅷ	ᅡ	아우	1.298
ᅸ	ᅣ	야오	1.297
ᅹ	ᅣ	야요	1.296
ᅺ	ᅥ	어요	1.295
ᅻ	ᅥ	어우	1.294
ᅼ	ᅥ	어으	1.293
ᅽ	ᅧ	여오	1.292
ᅾ	ᅧ	여우	1.291
ᅿ	ᅩ	오어	1.290
ᆀ	ᅩ	오에	1.289
ᆁ	ᅩ	오예	1.288
ᆂ	ᅩ	오오	1.287
ᆃ	ᅩ	오우	1.286
ᆄ	ᅭ	요야	1.285
ᆅ	ᅭ	요얘	1.284
ᆆ	ᅭ	요여	1.283
ᆇ	ᅭ	요오	1.282
ᆈ	ᅭ	요이	1.281
ᆉ	ᅮ	우아	1.280
ᆊ	ᅮ	우애	1.279
ᆋ	ᅮ	우으어	1.278
ᆌ	ᅮ	우예	1.277
ᆍ	ᅮ	우우	1.276
ᆎ	ᅲ	유아	1.275
ᆏ	ᅲ	유어	1.274
ᆐ	ᅲ	유에	1.273
ᆑ	ᅲ	유여	1.272
ᆒ	ᅲ	유예	1.271
ᆓ	ᅲ	유우	1.270
ᆔ	ᅲ	유이	1.269
ᆕ	ᅳ	으우	1.268
ᆖ	ᅳ	으으	1.267
ᆗ	ᅳ	의우	1.266
ᆘ	ᅵ	이아	1.265
ᆙ	ᅵ	이야	1.264
ᆚ	ᅵ	이오	1.263
ᆛ	ᅵ	이우	1.262
ᆜ	ᅵ	이으	1.261
ᆝ	ᅵ	이아래아	1.260
ᆞ	ᅡ	아래아	2.299
ᆟ	ᅡ	아래아어	1.258
ᆠ	ᅡ	아래아우	1.257
ᆡ	ᅡ	아래아이	1.256
ᆢ	ᅣ	아래야	2.298
ᅠ	ᅳ	無중성	1.254'''
jongtext=u'''			3.199
ᆨ	ᆨ	기역	3.198
ᆩ	ᆩ	쌍기역	3.197
ᆪ	ᆪ	기역시옷	3.196
ᆫ	ᆫ	니은	3.195
ᆬ	ᆬ	니은지읒	3.194
ᆭ	ᆭ	니은히읗	3.193
ᆮ	ᆮ	디귿	3.192
ᆯ	ᆯ	리을	3.191
ᆰ	ᆰ	리을기역	3.190
ᆱ	ᆱ	리을미음	3.189
ᆲ	ᆲ	리을비읍	3.188
ᆳ	ᆳ	리을시옷	3.187
ᆴ	ᆴ	리을티읕	3.186
ᆵ	ᆵ	리을피읖	3.185
ᆶ	ᆶ	리을히읗	3.184
ᆷ	ᆷ	미음	3.183
ᆸ	ᆸ	비읍	3.182
ᆹ	ᆹ	비읍시옷	3.181
ᆺ	ᆺ	시옷	3.180
ᆻ	ᆻ	쌍시옷	3.179
ᆼ	ᆼ	이응	3.178
ᆽ	ᆽ	지읒	3.177
ᆾ	ᆾ	치읓	3.176
ᆿ	ᆿ	키읔	3.175
ᇀ	ᇀ	티읕	3.174
ᇁ	ᇁ	피읖	3.173
ᇂ	ᇂ	히읗	3.172
ᇃ	ᆨ	기역리을	1.199
ᇄ	ᆨ	기역시옷기역	1.198
ᇅ	ᆫ	니은기역	1.197
ᇆ	ᆫ	니은디귿	1.196
ᇇ	ᆫ	니은시옷	1.195
ᇈ	ᆫ	니은시옷	1.194
ᇉ	ᆫ	니은티읕	1.193
ᇊ	ᆮ	디귿기역	1.192
ᇋ	ᆮ	디귿리을	1.191
ᇌ	ᆯ	리을기역시옷	1.190
ᇍ	ᆯ	리을니은	1.189
ᇎ	ᆯ	리을디귿	1.188
ᇏ	ᆯ	리을디귿히읗	1.187
ᇐ	ᆯ	리을리을	1.186
ᇑ	ᆯ	리을미음기역	1.185
ᇒ	ᆯ	리을미음시옷	1.184
ᇓ	ᆯ	리을비읍시옷	1.183
ᇔ	ᆯ	리을비읍히읗	1.182
ᇕ	ᆯ	리을여린비읍	1.181
ᇖ	ᆯ	리을쌍시옷	1.180
ᇗ	ᆯ	리을시옷	1.179
ᇘ	ᆯ	리을키읔	1.178
ᇙ	ᆯ	리을히읗	1.177
ᇚ	ᆷ	미음기역	1.176
ᇛ	ᆷ	미음리을	1.175
ᇜ	ᆷ	미음비읍	1.174
ᇝ	ᆷ	미음시옷	1.173
ᇞ	ᆷ	미음쌍시옷	1.172
ᇟ	ᆷ	미음시옷	1.171
ᇠ	ᆷ	미음치읓	1.170
ᇡ	ᆷ	미음히읗	1.169
ᇢ	ᆷ	여린미음	1.168
ᇣ	ᆸ	비읍리을	1.167
ᇤ	ᆸ	비읍피읖	1.166
ᇥ	ᆸ	비읍히읗	1.165
ᇦ	ᆸ	여린비읍	1.164
ᇧ	ᆺ	시옷기역	1.163
ᇨ	ᆺ	시옷디귿	1.162
ᇩ	ᆺ	시옷리을	1.161
ᇪ	ᆺ	시옷비읍	1.160
ᇫ	ᆺ	반시옷	1.159
ᇬ	ᆼ	이응기역	1.158
ᇭ	ᆼ	이응쌍기역	1.157
ᇮ	ᆼ	이응이응	1.156
ᇯ	ᆼ	이응키읔	1.155
ᇰ	ᆼ	옛이응	1.154
ᇱ	ᆼ	옛이응시옷	1.153
ᇲ	ᆼ	옛이응여린시옷	1.152
ᇳ	ᇁ	피읖비읍	1.151
ᇴ	ᇁ	여린피읖	1.150
ᇵ	ᇂ	히읗니은	1.149
ᇶ	ᇂ	히읗리을	1.148
ᇷ	ᇂ	히읗미음	1.147
ᇸ	ᇂ	히읗비읍	1.146
ᇹ	ᇂ	여린히읗	1.145'''
etctext=u'''〮	거성	거성(去聲)	0.099
〯	상성	상성(上聲)	0.098'''

def getlist(text):
	result = []
	for i in text.split('\n'):
		resultline = []
		cells = i.split('\t')
		resultline.append(cells[0])
		resultline.append(cells[1])
		resultline.append(cells[2])
		resultline.append(float(cells[3]))
		result.append(resultline)
	return result

#Get list from original text
cho = getlist(chotext)
jung = getlist(jungtext)
jong = getlist(jongtext)
etc = getlist(etctext)

#Make all yethangul syllables
syl=[]
for i in cho:
	for j in jung:
		for k in jong:
			s = []
			s.append(i[0]+j[0]+k[0])
			s.append(unicodedata.normalize('NFC',i[1]+j[1]+k[1]))
			s.append(i[2]+j[2]+k[2])
			s.append(i[3]+j[3]+k[3])
			if(len(unicodedata.normalize('NFC',s[0]))!=1):
				syl.append(s)

#Get index on highest value
def gethigh():
	highindex = 0
	highvalue = 0 
	for n in range(len(syl)):
		if syl[n][3] > highvalue:
			highvalue=syl[n][3]
			highindex = n
	return highindex

#Sort list
sortedsyl = []
while(len(syl)):
	n = gethigh()
	sortedsyl.append(syl[n])
	del syl[n]

#Print all lists as Hanja.txt style
for i in sortedsyl:
	print (i[1]+u":"+i[0]+u":"+i[2]).encode('utf-8')

for i in etc:
	print (i[1]+u":"+i[0]+u":"+i[2]).encode('utf-8')




